/* Motor de Vida Artificial. Motor 01

Autor: Rafael Alberto Moreno Parra
Pais: Colombia
E-mail: krousky@uniweb.net.co

Investigacin: Vida Artificial
Fecha: 27 de Agosto de 1999

Explicacin:
Genera algoritmos aleatorios que tomando la serie de entrada como valores X
trata de acercarse a la serie de salida (valores Y). Puede usar dos variables mas W y Z.

*/


import java.awt.*;
import java.applet.*;

public class Motor01 extends Applet implements Runnable
{
    //Trabajar con hilos
	private Thread	 m_thRunner = null;
	
	//Ambiente (series de entrada y salida)
	String m_sEntra = new String();
	String m_sSale = new String();
	
	//Ambiente y ser vivo
	MedioAmbiente objAmbiente = new MedioAmbiente();
	Organismo oSerVivo = new Organismo();
	int m_iNumGenes;
	int m_iNumCiclos;
		
	//Contador de Intentos
	int m_iContIntentos;
	
	//Tres primeros puestos
	String m_sPuesto1 = new String(); float m_fPuesto1;
	String m_sPuesto2 = new String(); float m_fPuesto2;
	String m_sPuesto3 = new String(); float m_fPuesto3;

    
	public void init()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(735,325);
		lblTitulo.setText("Motor de Vida Artificial. Motor 01.");
		add(lblTitulo);
		lblTitulo.setBackground(java.awt.Color.black);
		lblTitulo.setForeground(java.awt.Color.white);
		lblTitulo.setFont(new Font("Dialog", Font.BOLD, 16));
		lblTitulo.setBounds(12,12,346,26);
		lblEntrada.setText("Valores de Entrada:");
		add(lblEntrada);
		lblEntrada.setBounds(12,48,132,24);
		lblSalida.setText("Valores de Salida esperados:");
		add(lblSalida);
		lblSalida.setBounds(12,72,168,24);
		cmdIniciar.setLabel("Iniciar");
		add(cmdIniciar);
		cmdIniciar.setBounds(12,144,81,23);
		cmdDetener.setLabel("Detener");
		add(cmdDetener);
		cmdDetener.setBounds(108,144,80,22);
		lblGenes.setText("# de Genes (instrucciones) generadas por ser vivo:");
		add(lblGenes);
		lblGenes.setBounds(12,96,288,24);
		cmdSerVivo1.setLabel("Ser Vivo. 1er Puesto");
		add(cmdSerVivo1);
		cmdSerVivo1.setBounds(12,204,176,20);
		cmdSerVivo2.setLabel("Ser Vivo. 2do Puesto");
		add(cmdSerVivo2);
		cmdSerVivo2.setBounds(12,228,176,20);
		cmdSerVivo3.setLabel("Ser Vivo. 3er Puesto");
		add(cmdSerVivo3);
		cmdSerVivo3.setBounds(12,252,176,20);
		txtAprox1.setEditable(false);
		add(txtAprox1);
		txtAprox1.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtAprox1.setBounds(204,204,119,18);
		txtAprox2.setEditable(false);
		add(txtAprox2);
		txtAprox2.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtAprox2.setBounds(204,228,119,18);
		txtAprox3.setEditable(false);
		add(txtAprox3);
		txtAprox3.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtAprox3.setBounds(204,252,119,18);
		lblAproximacion.setText("Aproximacin");
		add(lblAproximacion);
		lblAproximacion.setBounds(204,180,120,18);
		txtEntra.setText("1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,");
		add(txtEntra);
		txtEntra.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtEntra.setBounds(180,48,540,24);
		txtSale.setText("2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,");
		add(txtSale);
		txtSale.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtSale.setBounds(180,72,540,24);
		txtGenes.setText("10");
		add(txtGenes);
		txtGenes.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtGenes.setBounds(300,96,36,19);
		add(txtCodFuente);
		txtCodFuente.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtCodFuente.setBounds(348,120,372,192);
		lblSerVivoCodFu.setText("Ser Vivo");
		add(lblSerVivoCodFu);
		lblSerVivoCodFu.setBounds(348,96,48,24);
		lblIntento.setText("Intento #:");
		add(lblIntento);
		lblIntento.setBounds(12,288,95,20);
		txtIntento.setEditable(false);
		add(txtIntento);
		txtIntento.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtIntento.setBounds(108,288,82,23);
		lblCiclosSerVivo.setText("# Mximo de Ciclos CPU para el Ser Vivo:");
		add(lblCiclosSerVivo);
		lblCiclosSerVivo.setBounds(12,120,274,21);
		txtCiclos.setText("30");
		add(txtCiclos);
		txtCiclos.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtCiclos.setBounds(300,120,36,19);
		txtPuesto.setEditable(false);
		add(txtPuesto);
		txtPuesto.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
		txtPuesto.setBounds(408,96,312,24);
		cmdContinuar.setLabel("Continuar");
		add(cmdContinuar);
		cmdContinuar.setBounds(204,144,83,21);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		cmdIniciar.addActionListener(lSymAction);
		cmdDetener.addActionListener(lSymAction);
		cmdSerVivo1.addActionListener(lSymAction);
		cmdSerVivo2.addActionListener(lSymAction);
		cmdSerVivo3.addActionListener(lSymAction);
		cmdContinuar.addActionListener(lSymAction);
		txtGenes.addActionListener(lSymAction);
		//}}

    	IniciarValores();
	
	}
	
	//{{DECLARE_CONTROLS
	java.awt.Label lblTitulo = new java.awt.Label();
	java.awt.Label lblEntrada = new java.awt.Label();
	java.awt.Label lblSalida = new java.awt.Label();
	java.awt.Button cmdIniciar = new java.awt.Button();
	java.awt.Button cmdDetener = new java.awt.Button();
	java.awt.Label lblGenes = new java.awt.Label();
	java.awt.Button cmdSerVivo1 = new java.awt.Button();
	java.awt.Button cmdSerVivo2 = new java.awt.Button();
	java.awt.Button cmdSerVivo3 = new java.awt.Button();
	java.awt.TextField txtAprox1 = new java.awt.TextField();
	java.awt.TextField txtAprox2 = new java.awt.TextField();
	java.awt.TextField txtAprox3 = new java.awt.TextField();
	java.awt.Label lblAproximacion = new java.awt.Label();
	java.awt.TextField txtEntra = new java.awt.TextField();
	java.awt.TextField txtSale = new java.awt.TextField();
	java.awt.TextField txtGenes = new java.awt.TextField();
	java.awt.TextArea txtCodFuente = new java.awt.TextArea();
	java.awt.Label lblSerVivoCodFu = new java.awt.Label();
	java.awt.Label lblIntento = new java.awt.Label();
	java.awt.TextField txtIntento = new java.awt.TextField();
	java.awt.Label lblCiclosSerVivo = new java.awt.Label();
	java.awt.TextField txtCiclos = new java.awt.TextField();
	java.awt.TextField txtPuesto = new java.awt.TextField();
	java.awt.Button cmdContinuar = new java.awt.Button();
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == cmdIniciar)
				cmdIniciar_ActionPerformed(event);
			else if (object == cmdDetener)
				cmdDetener_ActionPerformed(event);
			else if (object == cmdSerVivo1)
				cmdSerVivo1_ActionPerformed(event);
			else if (object == cmdSerVivo2)
				cmdSerVivo2_ActionPerformed(event);
			else if (object == cmdSerVivo3)
				cmdSerVivo3_ActionPerformed(event);
			else if (object == cmdContinuar)
				cmdContinuar_ActionPerformed(event);
			else if (object == txtGenes)
				txtGenes_ActionPerformed(event);
		}
	}

	void cmdIniciar_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    IniciarValores();
		start();
	}

	void cmdDetener_ActionPerformed(java.awt.event.ActionEvent event)
	{
        stop();			 
	}
	
	void cmdContinuar_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    start();
	}

	void cmdSerVivo1_ActionPerformed(java.awt.event.ActionEvent event)
	{
         txtCodFuente.setText(m_sPuesto1);
         txtPuesto.setText("1er Puesto. Aprox:" + txtAprox1.getText());
	}

	void cmdSerVivo2_ActionPerformed(java.awt.event.ActionEvent event)
	{
         txtCodFuente.setText(m_sPuesto2);
         txtPuesto.setText("2do Puesto. Aprox:" + txtAprox2.getText());
	}

	void cmdSerVivo3_ActionPerformed(java.awt.event.ActionEvent event)
	{
         txtCodFuente.setText(m_sPuesto3);
         txtPuesto.setText("3er Puesto. Aprox:" + txtAprox3.getText());
	}
	
	public void start()
	{
		if (m_thRunner == null)
		{
			m_thRunner = new Thread(this);
			m_thRunner.start();
		}
	}
	
	public void stop()
	{
		if (m_thRunner != null)
		{
			m_thRunner.stop();
			m_thRunner=null;
		}	

	}

	public void run()
	{
		float fResult, fErrOrg;
		int iCont;
		while(true)
		{
            m_iContIntentos++;
            txtIntento.setText(String.valueOf(m_iContIntentos));
	        oSerVivo.vCreaADN(m_iNumGenes, m_iNumCiclos);
    
	        /* Compara la cadena de salida del organismo con la requerida */
            fErrOrg=0;
	        for (iCont=0; iCont<objAmbiente.m_iContEntra; iCont++)
	        {
	            fResult = oSerVivo.fEvalOrganismo((float)objAmbiente.m_iEntradas[iCont]);
	            fErrOrg += Math.abs(fResult-(float)objAmbiente.m_iSalidas[iCont]);
	        }
	        
	        /* Compara con los tres puestos */
	        if (fErrOrg < m_fPuesto1)
	        {
	            m_sPuesto3 = m_sPuesto2;
	            m_fPuesto3 = m_fPuesto2;

	            m_sPuesto2 = m_sPuesto1;
	            m_fPuesto2 = m_fPuesto1;
	            
   	            m_sPuesto1 = oSerVivo.sDisplayADN();
	            m_fPuesto1 = fErrOrg;
	            
	            txtAprox1.setText(String.valueOf(m_fPuesto1));
	            txtAprox2.setText(String.valueOf(m_fPuesto2));
	            txtAprox3.setText(String.valueOf(m_fPuesto3));
	        }
	        else
	        if (fErrOrg < m_fPuesto2)
	        {
   	            m_sPuesto3 = m_sPuesto2;
	            m_fPuesto3 = m_fPuesto2;
	            
   	            m_sPuesto2 = oSerVivo.sDisplayADN();
	            m_fPuesto2 = fErrOrg;
	            
	            txtAprox2.setText(String.valueOf(m_fPuesto2));
	            txtAprox3.setText(String.valueOf(m_fPuesto3));
	        }
	        else
	        if (fErrOrg < m_fPuesto3)
	        {
   	            m_sPuesto3 = oSerVivo.sDisplayADN();
	            m_fPuesto3 = fErrOrg;
	            
	            txtAprox3.setText(String.valueOf(m_fPuesto3));
	        }
	    }
	}
	
    void IniciarValores()
	{
		//El ambiente
		m_sEntra = txtEntra.getText();
		m_sSale = txtSale.getText();
		
	    objAmbiente.vDeshaceIO(m_sEntra, 1);
	    objAmbiente.vDeshaceIO(m_sSale, 2);
		
    	//Valores iniciales de los puestos
		txtAprox1.setText("9999999");
		txtAprox2.setText("9999999");
		txtAprox3.setText("9999999");
        
		//Contador de Intentos
		m_iContIntentos = 0;
		
		//Inicializa los puestos
		m_sPuesto1=""; m_fPuesto1 = (float) 9999999;
		m_sPuesto2=""; m_fPuesto2 = (float) 9999999;
		m_sPuesto3=""; m_fPuesto3 = (float) 9999999;
		
		//Inicializa los genes y el numero de ciclos CPU requeridos para evaluar ser vivo
		m_iNumGenes = Integer.parseInt(txtGenes.getText());
		if (m_iNumGenes > 70)
		{
		    m_iNumGenes = 70;
		    txtGenes.setText("70");
		}
		m_iNumCiclos = Integer.parseInt(txtCiclos.getText());
	}	

	void txtGenes_ActionPerformed(java.awt.event.ActionEvent event)
	{
		if (Integer.parseInt(txtGenes.getText()) > 70)
		    txtGenes.setText("70");
	}
}
